Attribute VB_Name = "ProfileControls"
Option Explicit
Option Compare Binary

Private Sub Load_Mail()
Dim fileData As String
Dim arrIndex As Integer
Dim theName As String

    Dim FileNumber As Integer
    FileNumber = FreeFile
    '
    Open App.Path & "\Text\Mail.txt" For Input As #FileNumber
    Do Until EOF(FileNumber)
        Line Input #FileNumber, fileData
        'grab
            If InStrB(fileData, ACross) Then
            'if has indicator
                theName = Left$(fileData, InStr(fileData, ACross) - 1)
                '
                arrIndex = ChangeRealmNameToIndex(theName)
                'sets which array to put it into, and edits the filedata
                If InStrB(botElements.MailUsers(arrIndex), APointer & theName & ACross) = 0 Then botElements.MailUsers(arrIndex) = botElements.MailUsers(arrIndex) & APointer & theName & ACross
                'if not already in name list then add
            End If
        Loop
    Close #FileNumber

End Sub
'places mail into variable upon bot load

Public Sub Load_BotElements()
On Error GoTo Err

    With botElements
        .AccessUsers = get_AccessList(-1)
        'loads access required to add, and the access list
        .AutoCompleteWhispers = GetINI(INIGeneral, Str_AutoCompleteWhispers, , 1)
        .BnlsServer = GetINI(INIConnecting, Str_bnlsServer)
        .Buzz = GetINI(INIGeneral, Str_Buzz, , 0)
        .AccountActivity = GetINI(INIGeneral, Str_AccountActivity)
        .ChatColors = GetINI(INIGeneral, Str_ChatColors)
        .Hyperlinks = GetINI(INIGeneral, Str_HyperLinks)
        'sets wether or not to use account activity logging, chat colors, and link detection
        .FiltersBlockDuplicates = GetINI(INIGeneral, "FilterBlockDuplicates", , 1)
        .FiltersClientDeductable = GetINI(INIGeneral, "FilterClientDeductable", , 0)
        .FiltersDisableJoinLeaves = GetINI(INIGeneral, "FilterJoinLeaves", , 0)
        .FiltersSquelchLoads = GetINI(INIGeneral, "FilterSquelchLoads", , 1)
        'enables wether to filter out all joins n leaves during loads/floods
        'and if to hide all bans / kicks during
        Set_FiltersInArrays
        Set_FiltersOutArray
        'sets incoming and outgoing filters
        Recycle_Mail
        Load_Mail
        'remove old entries, then store users with mail
        .MailWithoutAccess = GetINI(INIGeneral, Str_MailWithoutAccess, , 0)
        .Memos = GetINI(INIGeneral, Str_Memos, , 1)
        .MinimalView = GetINI(INIGeneral, Str_MinimalView)
        '
        .PreviewProfile = GetINI(INIGeneral, Str_PreviewProfile, , 0)
        'enables or disables use of previewing profiles
        .RotateCDKeys = GetINI(INIConnecting, Str_RotateCDKeys, , 1)
        .SafelistAccess = GetINI(INIGeneral, Str_SafelistAccess)
        .SelfIcons = GetINI(INIGeneral, Str_SelfIcons, , 0)
        .JoinLeaves = GetINI(INIGeneral, Str_JoinLeaves)
        'sets logging on/off, if a user can mail without access, minimal layout yes/no, use self icons, show join and leaves
        .TimeLeft = GetINI(INITimestamps, Str_TimeLeft)
        .TimeRight = GetINI(INITimestamps, Str_TimeRight)
        If InStrB(.TimeRight, ASpace) Then .TimeRight = Replace$(.TimeRight, ASpace, AFakeSpace)
        'use fake spaces in time stamp right so names like www.bla.com dont show as links
        .TimeText = GetINI(INITimestamps, Str_TimeText)
        If LenB(.TimeText) = 0 Then .TimeText = "hh:mm:ss AM/PM"
        'set default if not already
        .WhisperWindow = GetINI(INIGeneral, Str_WhisperWindowLocation, , 2)
        'sets whisper window
        If .WhisperWindow = 0 Then frmMain.RtbWhisper.Text = vbNullString
        'if ww isnt used clear its text
        .VerbyteD2 = GetINI(INIConnecting, Str_VerbyteD2)
        .VerbyteSC = GetINI(INIConnecting, Str_VerbyteSC)
        .VerbyteW2 = GetINI(INIConnecting, Str_VerbyteW2)
        .VerbyteW3 = GetINI(INIConnecting, Str_VerbyteW3)
        'sets verbytes
        Dim tabName As String
        tabName = GetINI(INIGeneral, Str_TabName)
        If LenB(tabName) Then
            frmMain.tabTable.Tabs.Item(1).Caption = tabName
        Else
            frmMain.tabTable.Tabs.Item(1).Caption = "Hidden Tabs"
        End If
        'tab display for status window
    End With
    'variables

Err:
    'If Err.Number <> 0 Then handleProjectError -1, "Error:sub|Load_BotElements -> [" & Err.Number & "] " & Err.Description
End Sub
'loads data from the ini to botelements.

Public Sub Recycle_Mail()
Dim fileData As String, mailSplit() As String, mailOutput As String
Dim tmpDate As String, StringLoc As Integer

    Dim theDate As String
    theDate = Date$
    'todays date
    Dim FileNumber As Integer
    FileNumber = FreeFile
    '
    Open App.Path & "\Text\Mail.txt" For Input As #FileNumber
    Do Until EOF(FileNumber)
        Line Input #FileNumber, fileData
            If InStrB(fileData, ACross) Then
            'if has indicator
                mailSplit = Split(fileData, ACross)
                '
                If UBound(mailSplit) > 0 Then
                'if date exist, date will always be 10 chars long
                    StringLoc = InStr(mailSplit(1), "/")
                    If StringLoc > 10 Then
                    'if indicator found
                        tmpDate = Left$(mailSplit(1), StringLoc - 1)
                        'sets date for when mail was issued
                        If DateDiff("d", tmpDate, theDate) < 5 Then mailOutput = mailOutput & fileData & vbCrLf
                        'mail hasnt existed for 5 days yet
                        'build string
                    End If
                'if date exist
                End If
            'has cross indicator
            End If
    Loop
    Close #FileNumber
    'eliminate old mail
    
    Open App.Path & "\Text\Mail.txt" For Output As #FileNumber
    Print #FileNumber, mailOutput
    Close #1
    'save new

End Sub

Public Sub Set_ProfileVariables(ByVal Index As Integer, ByRef fileName As String)
On Error GoTo Err

    
    With aProfile(Index)
        If InStrB(fileName, "\") Then
        'if contains a slash then full path is already set
            .profilePath = fileName
        Else
            .profilePath = App.Path & "\Text\Profiles\" & fileName
            'we have to set this first because its used throughout this sub
            'for this variable we cut off the .ini part
        End If
        .AccessTrigger = GetINI(INIGeneral, Str_Trigger, .profilePath)
        If LenB(.AccessTrigger) = 0 Then .AccessTrigger = "!"
        'set a default trigger if one is not yet set
        .AccessUnique = GetINI(INIGeneral, Str_UniqueAccess, .profilePath, 0)
        '
        If .AccessUnique Then .AccessUsers = get_AccessList(Index)
        'load access if unqiue access
        If Not .Active Then
            ReDim .LinkData(0)
            'set
            Load_CoreVariables Index, .profilePath
            'load basics needed to connect
            If Not .Loaded Then
                AddChat 0, 0, &HC0C0C0, GetSTRING(99) & "Profile, " & .Name & "." & ChangeRealmIndexToName(Index) & " - " & StrReverse$(.GameClient) & ", " & GetSTRING(103) 'has been loaded."
            'has been loaded
            Else
                'AddChat 0, Index, vbYellow, GetSTRING(99) & "Profile, " & .Name & "." & ChangeRealmIndexToName(Index) & " - " & StrReverse$(.GameClient) & ", " & GetSTRING(157) 'has been saved."
            'has been saved
            End If
            '
            'ReDim .WebbotQueue(0)  'webbot//
        Else
            'when enabled this tells the bot to load basic settings upon disconnect
            'AddChat 0, Index, vbYellow, GetSTRING(99) & "Profile, " & .Name & "." & ChangeRealmIndexToName(Index) & " - " & StrReverse$(.GameClient) & ", " & GetSTRING(157) 'has been saved."
        End If
        'load core variables n such
        .AutoCP = CBool(GetINI(INIOperator, "AutoCP", .profilePath, 0))
        'auto cp
        .bnlsEnabled = GetINI(INIConnecting, Str_useBNLS, .profilePath, 0)
        'use bnls
        .ChannelHome = GetINI(INIConnecting, Str_Home, .profilePath)
        'sets home channel
        .ClientBans = GetINI(INIOperator, "ClientBans", .profilePath)
        'client bans
        .FilterHideBans = GetINI(INIGeneral, "FilterBans", .profilePath, 1)
        'sets hide bans
        If GetINI(INIMessaging, Str_JoinGreet, .profilePath, 0) Then
            .GreetJoinMessage = GetINI(INIMessaging, Str_GreetJoinMessage, .profilePath)
        Else
            .GreetJoinMessage = vbNullString
        End If
        'sets or removes join greet
        If GetINI(INIMessaging, Str_LeaveGreet, .profilePath, 0) Then
            .GreetLeaveMessage = GetINI(INIMessaging, Str_GreetLeaveMessage, .profilePath)
        Else
            .GreetLeaveMessage = vbNullString
        End If
        'sets or removes leave greets
        Get_ProfileIdle Index, .profilePath
        'sets idle information including type, interval, message
        .GuardLoadBan = GetINI(INIOperator, "LoadBanStatus", .profilePath, 1)
        .GuardLevel = GetINI(INIOperator, "LoadBanLevel", .profilePath, 22)
        'set auto load ban
        .Loaded = True
        'set loaded
        .Logging = GetINI(INIGeneral, Str_Logging, .profilePath, 1)
        'enables logging
        .PingType = GetINI(INIConnecting, Str_PingIndex, .profilePath, 1)
        'set ping type
        .PreviewProfile = GetINI(INIGeneral, Str_PreviewProfile, .profilePath, 1)
        'enable profile viewing for this prof
        .QueueSharing = GetINI(INIOperator, "QueueSharing", .profilePath, 0)
        '.WebbotEnabled = GetINI(INIWebbot, "Enabled", .ProfilePath, 0)  'webbot//
        '.WebbotPassword = GetINI(INIWebbot, TPassword, .ProfilePath)
        '.WebbotUsername = GetINI(INIWebbot, TUsername, .ProfilePath)
        'loads web bot info
        .Whisperback = GetINI(INIGeneral, Str_WhisperBack, .profilePath, 1)
        'whisper back cmds
    End With

Err:
    'If Err.Number <> 0 Then handleProjectError Index, "Error:sub|set_ProfileVariables -> [" & Err.Number & "] " & Err.Description
End Sub
'loads variables for a profile

Public Sub Load_CoreVariables(ByRef profileIndex As Integer, ByVal profPath As String)
On Error GoTo Err
    
    With aProfile(profileIndex)
        .BNETServer = GetINI(INIConnecting, Str_Server, profPath)
        ChangeRealmToIP .BNETServer
        'set server and change to IP format
        .BNETRealm = ChangeIPToRealmShort(.BNETServer)
        'obtain realm from IP
        .CDKey = GetINI(INIConnecting, Str_CDKey, profPath)
        .CDKeyExpansion = GetINI(INIConnecting, Str_CDKeyExpansion, profPath)
        'sets CDKeys
        .Name = GetINI(INIConnecting, TUsername, profPath)
        .Password = GetINI(INIConnecting, TPassword, profPath)
        'sets state to loaded, name and pass
        .GameClient = GetINI(INIConnecting, Str_Client, profPath)
        'sets client
        .Proxy = GetINI(INIConnecting, Str_UseProxy, profPath)
        'use proxy
    End With
    
Err:
End Sub
'loads basic things needed to connect

Public Sub Load_AProfile(ByRef fileName As String)
Dim profPath As String
Dim profileIndex As Integer
On Error GoTo Err

    profPath = App.Path & "\Text\Profiles\" & fileName
    '
    WriteINI INIGeneral, "HideTab_Once", "0", profPath
    'disable the hide once option as the profile is being loaded, as hide once
    'should only be applied during the load of which it was selected
    profileIndex = get_NextOpenProfileIndex
    'set path and index to use
    Load_ProfileControls profileIndex
    Set_ProfileOnTab False, profileIndex
    'load the whisper window, chat window ect
    Set_ProfileVariables profileIndex, fileName
    'applies variables to the profile
    Set_TabCaption profileIndex
    'sets the display for the tab
    If KeyPress(118) = 0 Then  'f7
        If GetINI(INIGeneral, Str_AutoConnect, profPath) Then ConnectProfile profileIndex, False
    'if set to connect on load
    Else
        AddChat 0, profileIndex, &HC0C0C0, GetSTRING(144) 'Connecting on load has been manually halted.
    End If
    'if F7 isn't held down on startup the bot will connect profiles marked as "connect on load"
    
Err:
    'If Err.Number <> 0 Then handleProjectError profileIndex, "Error:sub|Load_AProfile -> [" & Err.Number & "] " & Err.Description
    'display err if is one
    
End Sub
'calls all routines needed to start a profile and prepare it for connecting (without using the config)

Public Sub Set_TabCaption(ByRef profileIndex As Integer)
Dim tabNumber As Integer

    tabNumber = get_TabOnProfile(profileIndex)
    If tabNumber <> -1 Then
        Dim theName As String
        theName = GetINI(INIGeneral, Str_TabName, aProfile(profileIndex).profilePath)
        If LCase$(theName) = "%p" Then theName = GetINI(INIGeneral, Str_ProfileName, aProfile(profileIndex).profilePath)
        'if set to use profile name then set it
        If LenB(theName) = 0 Then
            If aProfile(profileIndex).Connected Then
                theName = AttachRealmSingle(aProfile(profileIndex).RealName, profileIndex)
            'connected, use unique name and realm(client specific) type
            Else
                theName = AttachRealmSingle(aProfile(profileIndex).Name, profileIndex)
            'not connected show name and realm
            End If
            'sets display name
        End If
        'if no name stored in ini for this tab
        frmMain.tabTable.Tabs(tabNumber).Caption = theName
    End If
    
End Sub
'sets the tab caption with the profiles details

Private Sub Get_ProfileIdle(ByRef profileIndex As Integer, ByRef profPath As String)

    With aProfile(profileIndex)
        
        .IdleMInterval = 0
        .IdleMMessage = vbNullString
        .IdleMType = 0
        'reset
        If GetINI(INIMessaging, Str_Idle, profPath, 0) Then
            .IdleMMessage = GetINI(INIMessaging, Str_IdleMessage, profPath)
            .IdleMType = Val#(GetINI(INIMessaging, Str_IdleType, profPath))
            .IdleMInterval = Val#(GetINI(INIMessaging, Str_IdleInterval, profPath))
        End If
        'set only if idles are enabled

    End With
    
End Sub
'loads and or resets idle data based on enabled status

'n// random note.. if i want this to work completely independent per channel per server
'tagbans shitlist sync and ban list must all work per channel.
Public Sub Load_ProfileControls(ByRef iProfile As Integer)
On Error GoTo Err

    Load frmMain.lstGreetedUsers(iProfile)
    Load frmMain.lstUserStorage(iProfile)
    Load frmMain.wS(iProfile)
    Load frmMain.RtbTalk(iProfile)
    '
    Load frmMain.lstQueueData(iProfile)
    Load frmMain.lstIdleTicks(iProfile)
    'n// we only tmp load bnls winsock upon profile connecting to keep it clean
    'loads objects
    frmMain.lstGreetedUsers(iProfile).Clear
    frmMain.lstUserStorage(iProfile).Clear
    frmMain.RtbTalk(iProfile).Text = MultipleReturns
    frmMain.lstQueueData(iProfile).Clear
    frmMain.lstIdleTicks(iProfile).Clear
    'we have to clear these controls or they use copied data from the spawn
    frmMain.RtbTalk(iProfile).ZOrder 0
    If botElements.WhisperWindow <> 0 Then frmMain.RtbWhisper.ZOrder 0
    'if this isnt done you can see the profile tabs overlaying the rtb.

Err:

    If iProfile > UBound(aProfile) Then ReDim Preserve aProfile(iProfile)
    'raise if higher than max
  
End Sub
'loads needed objects and returns profile match #

Public Function get_TabOnProfile(ByRef profileIndex As Integer) As Integer
Dim arrIndex As Integer

    get_TabOnProfile = -1
    For arrIndex = 1 To UBound(botElements.ProfileOnTab)
        If botElements.ProfileOnTab(arrIndex) = profileIndex Then
            get_TabOnProfile = (arrIndex)
            Exit Function
        End If
    Next arrIndex
    'runs through until profileontab aligns with the profileindex

End Function
'gets the tab for the specified profile index

Public Function get_ProfileOnTab(ByRef tabIndex As Integer)

    'cant get a profile for status window
    get_ProfileOnTab = botElements.ProfileOnTab(tabIndex)

End Function
'gets the index of the profile on the specified tab index


Public Sub Set_ProfileOnTab(ByRef RemoveEntry As Boolean, Optional ByRef profileIndex As Integer, Optional ByRef tabIndex As Integer)
Dim arrIndex As Integer

    If RemoveEntry Then
    
        aProfile(profileIndex).TabHidden = True
        'the tab is either hidden or profile is not loaded, either way this works
        arrIndex = tabIndex
        'starting point
        For arrIndex = (tabIndex + 1) To frmMain.tabTable.Tabs.Count
            botElements.ProfileOnTab(arrIndex - 1) = botElements.ProfileOnTab(arrIndex)
        Next
        'this will bump each profile on tab down one.
        'so if we say remove Tab 3 / 6, 3 then becomes 4, 4 then becomes 5, 5 then becomes 6, and 6 is discarded
        frmMain.tabTable.Tabs.Remove tabIndex
        'remove the tab
        If UBound(botElements.ProfileOnTab) > frmMain.tabTable.Tabs.Count Then ReDim Preserve botElements.ProfileOnTab(frmMain.tabTable.Tabs.Count)
        'discard extras

    'if removing a tab
    Else
    
        aProfile(profileIndex).TabHidden = False
        'tab isnt hidden if its loaded
        frmMain.tabTable.Tabs.Add , , aProfile(profileIndex).Name, 2
        'add tab
        ReDim Preserve botElements.ProfileOnTab(frmMain.tabTable.Tabs.Count)
        'the count should always increase while adding so always re dim
        botElements.ProfileOnTab(UBound(botElements.ProfileOnTab)) = profileIndex
        'add entry to our array
        AddChat 0, profileIndex, vbYellow, GetSTRING(151) 'Notice --- To unload a profile, press Escape while viewing the profile you wish to unload.
        '
    'if adding a tab
    End If

End Sub
'this routine will add or remove a tab and update the profile on tab

Public Function get_NextOpenProfileIndex() As Integer
Dim iProfileslot As Integer

  iProfileslot = 1
  'start on 1 since slot 0 is for the status window
  Do Until iProfileslot > UBound(aProfile)
    
    If Not aProfile(iProfileslot).Loaded Then
      get_NextOpenProfileIndex = iProfileslot
      'sets because is empty
      Exit Function
    End If
    'match found
    
    iProfileslot = iProfileslot + 1
    'next
    
  Loop
  'loop until we get to the end of aprofile
  'if we get to the end then L - U is taken and use U+1
  If iProfileslot > UBound(aProfile) Then ReDim Preserve aProfile(iProfileslot)
  'if slot doesn't exist and is an addition then redim
  get_NextOpenProfileIndex = iProfileslot
  'all contain data, do next

End Function
'gets the next available profile index



