VERSION 5.00
Begin VB.Form frmFilters 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   5220
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   9540
   Icon            =   "frmFilters.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5220
   ScaleWidth      =   9540
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame FrameFilters 
      BorderStyle     =   0  'None
      Height          =   5295
      Left            =   0
      TabIndex        =   0
      Top             =   -120
      Width           =   9615
      Begin VB.Frame Frame2 
         Caption         =   "Profile Specific Automatic Filter Options"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   615
         Left            =   4800
         TabIndex        =   18
         Top             =   2760
         Width           =   4575
         Begin VB.CheckBox CheckHideBans 
            Caption         =   "Filter out ban and kick messages."
            Height          =   255
            Left            =   120
            TabIndex        =   19
            Top             =   240
            Width           =   4215
         End
      End
      Begin VB.Frame Frame1 
         Caption         =   "Global Automatic Filter Options **"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   1695
         Left            =   4800
         TabIndex        =   13
         Top             =   3480
         Width           =   4575
         Begin VB.CheckBox CheckClientDeductable 
            Caption         =   "Be less aggressive towards warcraft3 and diablo2 clients"
            Height          =   255
            Left            =   120
            TabIndex        =   17
            Top             =   1320
            Width           =   4335
         End
         Begin VB.CheckBox CheckBlockDuplicates 
            Caption         =   "Block all chat from name duplicates (name#2 ect)"
            Height          =   255
            Left            =   120
            TabIndex        =   16
            Top             =   960
            Width           =   4095
         End
         Begin VB.CheckBox CheckSquelchLoads 
            Caption         =   "Squelch random loads when idle to block spam."
            Height          =   255
            Left            =   120
            TabIndex        =   15
            Top             =   600
            Width           =   4335
         End
         Begin VB.CheckBox CheckDisableJoinLeaves 
            Caption         =   "Disable Join Leave Messages completely."
            Height          =   255
            Left            =   120
            TabIndex        =   14
            Top             =   240
            Width           =   3975
         End
      End
      Begin VB.Frame FrameFiltersOut 
         Caption         =   "Outgoing Filters **"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   2295
         Left            =   120
         TabIndex        =   8
         Top             =   2880
         Width           =   4575
         Begin VB.CommandButton CmdFilterAddOutgoing 
            Caption         =   "Add An Outgoing Filter"
            Height          =   375
            Left            =   120
            TabIndex        =   10
            Top             =   1800
            Width           =   4335
         End
         Begin VB.ListBox lstFilteredOutgoing 
            Height          =   1230
            Left            =   120
            TabIndex        =   9
            Top             =   480
            Width           =   4335
         End
         Begin VB.Label Label24 
            Caption         =   "Original Message --> Replace With"
            Height          =   255
            Left            =   120
            TabIndex        =   11
            Top             =   240
            Width           =   2655
         End
      End
      Begin VB.Frame FrameFiltersIn 
         Caption         =   "Incoming Filters **"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   2295
         Left            =   120
         TabIndex        =   1
         Top             =   480
         Width           =   4575
         Begin VB.ListBox lstFilteredNames 
            Height          =   1230
            Left            =   120
            TabIndex        =   5
            Top             =   480
            Width           =   1575
         End
         Begin VB.ListBox lstFilteredMessages 
            Height          =   1230
            Left            =   1800
            TabIndex        =   4
            Top             =   480
            Width           =   2655
         End
         Begin VB.CommandButton cmdFilterAddMessage 
            Caption         =   "Filter A Message"
            Height          =   375
            Left            =   1800
            TabIndex        =   3
            Top             =   1800
            Width           =   2655
         End
         Begin VB.CommandButton cmdFilterAddName 
            Caption         =   "Filter A Name"
            Height          =   375
            Left            =   120
            TabIndex        =   2
            Top             =   1800
            Width           =   1575
         End
         Begin VB.Label Label22 
            Caption         =   "Names"
            Height          =   255
            Left            =   120
            TabIndex        =   7
            Top             =   240
            Width           =   1575
         End
         Begin VB.Label Label23 
            Caption         =   "Message"
            Height          =   255
            Left            =   1800
            TabIndex        =   6
            Top             =   240
            Width           =   2655
         End
      End
      Begin VB.Shape Shape5 
         BackColor       =   &H80000010&
         BackStyle       =   1  'Opaque
         Height          =   2415
         Left            =   4800
         Top             =   240
         Width           =   4575
      End
      Begin VB.Label Label1 
         Alignment       =   2  'Center
         Caption         =   "Double click filters to remove them."
         Enabled         =   0   'False
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   240
         Width           =   4575
      End
   End
End
Attribute VB_Name = "frmFilters"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim form_ProfileIndex As Integer
'holds the index of the profile currently using this form
'used for remembering where to save things and such

Public Function get_ProfileIndex() As Integer
    get_ProfileIndex = form_ProfileIndex
End Function
'checked when user logs on, to see if they changed their name or anything


Public Sub Load_FiltersIn()
Dim arrIndex As Integer

    lstFilteredNames.Clear
    For arrIndex = 0 To (frmMain.lstFilteredNames.ListCount - 1)
        If LenB(frmMain.lstFilteredNames.List(arrIndex)) Then lstFilteredNames.AddItem Mid$(frmMain.lstFilteredNames.List(arrIndex), 2, InStr(frmMain.lstFilteredNames.List(arrIndex), ACross) - 2)
    Next arrIndex
    'display filtered names
    
    lstFilteredMessages.Clear
    For arrIndex = 0 To UBound(botElements.FiltersInMessages)
        If LenB(botElements.FiltersInMessages(arrIndex)) Then lstFilteredMessages.AddItem botElements.FiltersInMessages(arrIndex)
    Next arrIndex
    'display filtered messages
    
    lstFilteredOutgoing.Clear
    For arrIndex = 0 To UBound(botElements.FiltersOut)
        If LenB(botElements.FiltersOut(arrIndex)) Then lstFilteredOutgoing.AddItem botElements.FiltersOut(arrIndex)
    Next arrIndex
    'display outgoing filters

End Sub

Private Sub CheckBlockDuplicates_Click()
    WriteINI INIGeneral, "FilterBlockDuplicates", CheckBlockDuplicates.Value
    botElements.FiltersBlockDuplicates = CheckBlockDuplicates.Value
End Sub
'block # name chat

Private Sub CheckClientDeductable_Click()
    WriteINI INIGeneral, "FilterClientDeductable", CheckClientDeductable.Value
    botElements.FiltersClientDeductable = CheckClientDeductable.Value
End Sub

Private Sub CheckDisableJoinLeaves_Click()
    WriteINI INIGeneral, "FilterJoinLeaves", CheckDisableJoinLeaves.Value
    botElements.FiltersDisableJoinLeaves = CheckDisableJoinLeaves.Value
End Sub
'save filter all join leaves or not

Private Sub CheckHideBans_Click()
    WriteINI INIGeneral, "FilterBans", CheckHideBans.Value, aProfile(botElements.ActiveChatIndex).profilePath
    aProfile(botElements.ActiveChatIndex).FilterHideBans = CheckHideBans.Value
End Sub
'hide ban messages that are detected as hostile or not


Private Sub CheckSquelchLoads_Click()
    WriteINI INIGeneral, "FilterSquelchLoads", CheckSquelchLoads.Value
    botElements.FiltersSquelchLoads = CheckSquelchLoads.Value
End Sub
'iggy random loads

Private Sub cmdFilterAddMessage_Click()
Dim boxResponse As String

    boxResponse = InputBox("Enter a message to filter, all message filters are considered partial matches.", "Add Message Filter")
    If LenB(boxResponse) Then
        frmMain.Set_MessageFilter LCase$(boxResponse)
        'if a name has been entered then add it to filters
        Load_FiltersIn
        'refresh
    End If
    
End Sub

Private Sub cmdFilterAddName_Click()
Dim boxResponse As String


    If Not aProfile(form_ProfileIndex).Connected Then
        AddChat 0, botElements.ActiveChatIndex, vbYellow, GetSTRING(163) 'Notice --- Selected profile is not connected, cannot add filter.
        Exit Sub
    End If
    'announce

    boxResponse = InputBox("Enter a name to filter, name filters are exact.", "Add Name Filter")
    If LenB(boxResponse) Then
    'if not null and bot is connected
    'required to add because filters include realm conversion. not required to remove
        frmMain.Set_NameFilter LCase$(boxResponse)
        'if a name has been entered then add it to filters
        Load_FiltersIn
        'refresh
    End If
    
End Sub
'adds a name filter


Private Sub CmdFilterAddOutgoing_Click()
Dim boxResponse1 As String
Dim boxResponse2 As String

    boxResponse1 = InputBox("Enter the text you wish to replace, entries are case sensitive.", "Add Outgoing Filter")
    If LenB(boxResponse1) Then boxResponse2 = InputBox("What do you wish to replace '" & boxResponse1 & "' with?", "Add Outgoing Filter")
    'not required to be connected since outgoing filters dont require any name conversion
    If LenB(boxResponse2) Then
        lstFilteredOutgoing.AddItem boxResponse1 & "   *|*   " & boxResponse2
        'add to list
        Save_OutgoingFilters
        'save
        Load_FiltersIn
        'refresh
    'add if both strings have data
    End If

'set_FiltersOutArray()
End Sub

Private Sub Form_Load()
    FormsOpen.Filters = True
End Sub

Public Sub Set_ProfileIndex(ByRef Index As Integer)
    
    form_ProfileIndex = Index
    'set profile using this form
    Me.Caption = "Filters: " & aProfile(Index).Name & "." & ChangeRealmIndexToName(Index)
    'caption
    Load_FiltersIn
    'editing access
    Set_FilterOptions
    '
    
End Sub
'set the profile changing settings

Public Sub Set_FilterOptions()

    With frmFilters
        .CheckClientDeductable = GetINI(INIGeneral, "FilterClientDeductable", , 0)
        .CheckBlockDuplicates.Value = GetINI(INIGeneral, "FilterBlockDuplicates", , 1)
        .CheckSquelchLoads.Value = GetINI(INIGeneral, "FilterSquelchLoads", , 1)
        .CheckDisableJoinLeaves.Value = GetINI(INIGeneral, "FilterJoinLeaves", , 1)
        .CheckHideBans.Value = GetINI(INIGeneral, "FilterBans", aProfile(botElements.ActiveChatIndex).profilePath, 0)
    End With
    'sets values. values are written when they are checked, no save button
    
End Sub
'sets the checkmark values of filters

Private Sub Form_Unload(Cancel As Integer)
    FormsOpen.Filters = False
End Sub
'unset so bot doesnt think form is open

Private Sub lstFilteredMessages_DblClick()
    
    If lstFilteredMessages.listIndex = -1 Then Exit Sub
    'if nothing to select
    Save_MessageFilters
    'save whats left
    Load_FiltersIn
    'refresh filters
   
End Sub
'removes a message filter

Private Sub lstFilteredNames_DblClick()
    
    If lstFilteredNames.listIndex = -1 Then Exit Sub
    'if nothing to select
    frmMain.remove_NameFilter lstFilteredNames.List(lstFilteredNames.listIndex)
    'issue removal
    Load_FiltersIn
    'refresh filters
    
End Sub
'removes a name filter

Private Sub Save_MessageFilters()
Dim arrIndex As Integer, buildString As String

    Dim theMessage As String
    theMessage = lstFilteredMessages.List(lstFilteredMessages.listIndex)
    'store
    lstFilteredMessages.RemoveItem lstFilteredMessages.listIndex
    'remove entry
    
    For arrIndex = 0 To (lstFilteredMessages.ListCount - 1)
        buildString = buildString & lstFilteredMessages.List(arrIndex) & vbCrLf
    Next arrIndex
    'builds new list
    
    Dim FileNumber As Integer
    FileNumber = FreeFile
    '
    Open App.Path & "\Text\Filtered_Messages.txt" For Output As #FileNumber
    Print #FileNumber, buildString
    Close #FileNumber
    'write to build
    
    AddChat 0, botElements.ActiveChatIndex, &H80FF&, "'" & theMessage & "'", &H40C0&, GetSTRING(164)         'is no longer filtered.
    'exact match has been unfiltered

    Set_FiltersInArrays
    're-build array


End Sub
'unfilters a message


Private Sub Save_OutgoingFilters()
Dim arrIndex As Integer, buildString As String
    
    For arrIndex = 0 To (lstFilteredOutgoing.ListCount - 1)
        buildString = buildString & lstFilteredOutgoing.List(arrIndex) & vbCrLf
    Next arrIndex
    'builds new list
    
    Dim FileNumber As Integer
    FileNumber = FreeFile
    '
    Open App.Path & "\Text\Outgoing_Filters.txt" For Output As #FileNumber
    Print #FileNumber, buildString
    Close #FileNumber
    'write to build
    
    Set_FiltersOutArray
    're-build array


End Sub
'unfilters a message


Private Sub lstFilteredOutgoing_dblClick()

    If lstFilteredOutgoing.listIndex = -1 Then Exit Sub
    'nothing to select
    lstFilteredOutgoing.RemoveItem lstFilteredOutgoing.listIndex
    'remove
    Save_OutgoingFilters
    'save
    
End Sub
'dont feel like adding chat
